﻿package
{
	import flash.display.*;
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.events.MouseEvent;
	import flash.geom.*;

	public class Progresser extends Sprite
	{
		private var drawer:Sprite;
		private var data:BitmapData;
		private var background:Bitmap;
		
		//SETTINGS
		private var counter:Number;
		private var stepper:Number = 9;//c'est ici qu'il faut placer la vitesse
		private var separator:Number = Math.sin(2);
		private var line:Number;
		
		public function Progresser()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			addEventListener(Event.ENTER_FRAME, draw);
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		
		private function clickHandler(e:MouseEvent):void
		{
			removeChildAt(0);
			data = null;
		}
		
		private function fullhandler(e:FullScreenEvent):void
		{
			removeChildAt(0);
			data = null;
		}
		
		private function setup():void
		{
			data = new BitmapData(stage.stageWidth,stage.stageHeight,true,0x000000);
			background = new Bitmap(data);
			addChildAt(background,0);
			drawer = new Sprite();
			counter = 1;
			line = 10;
		}
		
		private function draw(e:Event):void
		{
			if(data == null){
				setup();
			}
			counter++;
			for(var i:Number = 0;i<100;i++){
			drawer.graphics.clear();
			var _height:Number = stage.stageHeight/stepper;
			var _width:Number = stage.stageWidth/stepper;
			var posx:Number = mouseX-(stage.width/(stepper*2));
			var posy:Number = mouseY-(stage.height)/(stepper*2);
			
			var fillType:String = GradientType.LINEAR;
  			var colors:Array = [0xFF0000, 0x000000];
  			var alphas:Array = [.5, 1];
  			var ratios:Array = [0x00, 0xFF];
  			var matr:Matrix = new Matrix();
  			matr.createGradientBox(_width/stepper, _height/stepper,45,posx,posy);
  			var spreadMethod:String = SpreadMethod.PAD;

			
			//dessiner progressivement par ligne un rectangle avec alpha dépendant du séparator

			drawer.graphics.beginGradientFill(GradientType.LINEAR, colors, alphas, ratios, matr, spreadMethod);
			drawer.graphics.lineStyle(4,0xC8F028,.6);			
			drawer.graphics.drawCircle(posx,posy,((counter/1000) / Math.sin(i)));
			drawer.graphics.lineStyle(1,0xffffff,.1);
			drawer.graphics.lineTo(stage.width/2,stage.height/2);
			drawer.graphics.endFill();
			
			//dessiner dans le bmpdt
			data.draw(drawer);
			
			//condition
			if(_width >= stage.stageWidth){
				counter = 0;
				line++;
			}
			if(posy>=stage.stageHeight){
				line = 0;
			}
		}
		}
	}
}